/*----- PROTECTED REGION ID(MCCE2Electrometers.h) ENABLED START -----*/
//=============================================================================
//
// file :        MCCE2Electrometers.h
//
// description : Include file for the MCCE2Electrometers class
//
// project :     Novelec MCCE-2 Electrometers
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef MCCE2Electrometers_H
#define MCCE2Electrometers_H

#include <tango.h>
#include "AbstractElectrometerClass.h"
#include "ElectrometerException.h"





/*----- PROTECTED REGION END -----*/	//	MCCE2Electrometers.h

/**
 *  MCCE2Electrometers class description:
 *    This class allows you to control all MCCE-2 Novelec electrometers
 *    through a Serial bus.
 *    <br> Supported types :
 *    <br> Novelec Electrometers : MCCE2
 */

namespace MCCE2Electrometers_ns
{
/*----- PROTECTED REGION ID(MCCE2Electrometers::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	MCCE2Electrometers::Additional Class Declarations

class MCCE2Electrometers : public Tango::Device_4Impl
{

/*----- PROTECTED REGION ID(MCCE2Electrometers::Data Members) ENABLED START -----*/

//	Add your own data members
public:



/*----- PROTECTED REGION END -----*/	//	MCCE2Electrometers::Data Members

//	Device property data members
public:
	//	ProxyName:	The name of the device which manages the communication.
	string	proxyName;
	//	Electrometer1Address:	The first electrometer address configured. <br />
	//  Note : if not connected, push 0 or let empty the property.
	Tango::DevUShort	electrometer1Address;
	//	Electrometer2Address:	The second electrometer address configured. <br />
	//  Note : if not connected, push 0 or let empty the property.
	Tango::DevUShort	electrometer2Address;
	//	ComProtocol:	Communication protocal: ETHERNET/SERIAL
	string	comProtocol;

//	Attribute data members
public:
	Tango::DevUShort	*attr_electrometerChannel_read;
	Tango::DevString	*attr_range1_read;
	Tango::DevString	*attr_range2_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	MCCE2Electrometers(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	MCCE2Electrometers(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	MCCE2Electrometers(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~MCCE2Electrometers() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : MCCE2Electrometers::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute electrometerChannel related methods
 *	Description: MCCE2 electrometer have two channels to support two amplifiers.\nWARN : default is 0 (please set this value first).
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_electrometerChannel(Tango::Attribute &attr);
	virtual void write_electrometerChannel(Tango::WAttribute &attr);
	virtual bool is_electrometerChannel_allowed(Tango::AttReqType type);
/**
 *	Attribute range1 related methods
 *	Description: The channel one MCCE2 range.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_range1(Tango::Attribute &attr);
	virtual bool is_range1_allowed(Tango::AttReqType type);
/**
 *	Attribute range2 related methods
 *	Description: The channel two MCCE range.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_range2(Tango::Attribute &attr);
	virtual bool is_range2_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : MCCE2Electrometers::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
	 *
	 *	@returns State Code
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command Status related method
	 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
	 *
	 *	@returns Status description
	 */
	virtual Tango::ConstDevString dev_status();
	/**
	 *	Command RangeUP related method
	 *	Description: 
	 *
	 */
	virtual void range_up();
	virtual bool is_RangeUP_allowed(const CORBA::Any &any);
	/**
	 *	Command RangeDOWN related method
	 *	Description: 
	 *
	 */
	virtual void range_down();
	virtual bool is_RangeDOWN_allowed(const CORBA::Any &any);
	/**
	 *	Command SetZeroVFFunction related method
	 *	Description: 
	 *
	 */
	virtual void set_zero_vffunction();
	virtual bool is_SetZeroVFFunction_allowed(const CORBA::Any &any);
	/**
	 *	Command SetOffsetZeroV1Function related method
	 *	Description: 
	 *
	 */
	virtual void set_offset_zero_v1_function();
	virtual bool is_SetOffsetZeroV1Function_allowed(const CORBA::Any &any);
	/**
	 *	Command SetLeakageZeroV2Function related method
	 *	Description: 
	 *
	 */
	virtual void set_leakage_zero_v2_function();
	virtual bool is_SetLeakageZeroV2Function_allowed(const CORBA::Any &any);
	/**
	 *	Command SetTestFunction related method
	 *	Description: 
	 *
	 */
	virtual void set_test_function();
	virtual bool is_SetTestFunction_allowed(const CORBA::Any &any);
	/**
	 *	Command SetMeasureFunction related method
	 *	Description: 
	 *
	 */
	virtual void set_measure_function();
	virtual bool is_SetMeasureFunction_allowed(const CORBA::Any &any);
	/**
	 *	Command MCCE2_ON related method
	 *	Description: 
	 *
	 */
	virtual void mcce2__on();
	virtual bool is_MCCE2_ON_allowed(const CORBA::Any &any);
	/**
	 *	Command MCCE2_OFF related method
	 *	Description: 
	 *
	 */
	virtual void mcce2__off();
	virtual bool is_MCCE2_OFF_allowed(const CORBA::Any &any);
	/**
	 *	Command Local related method
	 *	Description: 
	 *
	 */
	virtual void local();
	virtual bool is_Local_allowed(const CORBA::Any &any);
	/**
	 *	Command Remote related method
	 *	Description: 
	 *
	 */
	virtual void remote();
	virtual bool is_Remote_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: 
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command ClearRegisters related method
	 *	Description: 
	 *
	 */
	virtual void clear_registers();
	virtual bool is_ClearRegisters_allowed(const CORBA::Any &any);
	/**
	 *	Command GetRange related method
	 *	Description: 
	 *
	 *	@returns The actual electrometer range
	 */
	virtual Tango::DevString get_range();
	virtual bool is_GetRange_allowed(const CORBA::Any &any);
	/**
	 *	Command SetRange related method
	 *	Description: 
	 *
	 *	@param argin The range to apply on the electrometer
	 */
	virtual void set_range(Tango::DevString argin);
	virtual bool is_SetRange_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMode related method
	 *	Description: 
	 *
	 *	@returns The electrometer mode (MEASURE, LEAKAGE ...)
	 */
	virtual Tango::DevString get_mode();
	virtual bool is_GetMode_allowed(const CORBA::Any &any);
	/**
	 *	Command GetPolarity related method
	 *	Description: 
	 *
	 *	@returns The electrometer polarity
	 */
	virtual Tango::DevString get_polarity();
	virtual bool is_GetPolarity_allowed(const CORBA::Any &any);
	/**
	 *	Command SetPolarity related method
	 *	Description: 
	 *
	 *	@param argin POSITIVE or NEGATIVE
	 */
	virtual void set_polarity(Tango::DevString argin);
	virtual bool is_SetPolarity_allowed(const CORBA::Any &any);
	/**
	 *	Command GetHzFilter related method
	 *	Description: 
	 *
	 *	@returns The MCCE2 cut-off frequency in Hz
	 */
	virtual Tango::DevShort get_hz_filter();
	virtual bool is_GetHzFilter_allowed(const CORBA::Any &any);
	/**
	 *	Command SetHzFilter related method
	 *	Description: 
	 *
	 *	@param argin The MCCE2 cut-off frequency in Hz
	 */
	virtual void set_hz_filter(Tango::DevShort argin);
	virtual bool is_SetHzFilter_allowed(const CORBA::Any &any);
	/**
	 *	Command GetGain related method
	 *	Description: 
	 *
	 *	@returns The MCCE2 gain
	 */
	virtual Tango::DevShort get_gain();
	virtual bool is_GetGain_allowed(const CORBA::Any &any);
	/**
	 *	Command SetGain related method
	 *	Description: 
	 *
	 *	@param argin The new MCCE-2 gain
	 */
	virtual void set_gain(Tango::DevUShort argin);
	virtual bool is_SetGain_allowed(const CORBA::Any &any);
	/**
	 *	Command GetElectrometerTypeStr related method
	 *	Description: 
	 *
	 *	@param argin channel number
	 *	@returns the electrometer type as string
	 */
	virtual Tango::DevString get_electrometer_type_str(Tango::DevUShort argin);
	virtual bool is_GetElectrometerTypeStr_allowed(const CORBA::Any &any);


/*----- PROTECTED REGION ID(MCCE2Electrometers::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :
  AbstractElectrometerClass*  _electrometer;

  std::string _statusStr;

  std::string _notConnectedStr;

  bool _init_done;    //- used to allow device to start !!
  bool _missing_property;
  bool _updateRange1FromHW;
  bool _updateRange2FromHW;
  //- electrometer(s) type as string
  std::string _electroCH1StrType;
  std::string _electroCH2StrType;

  std::string read_range_from_hw();

  //- Method to convert all electrometer exceptions on Tango exception
  Tango::DevFailed electrometer_to_tango_exception(const electrometer::ElectrometerException& de);

private :
  AbstractElectrometerClass*  _electrometerCH1; //- electrometer on channel 1
  AbstractElectrometerClass*  _electrometerCH2; //- electrometer on channel 2
	Tango::DevUShort	attr_electrometerChannel_write;

  //- instanciate electrometer(s) obj
  void create_electrometers_obj();
  

/*----- PROTECTED REGION END -----*/	//	MCCE2Electrometers::Additional Method prototypes
};

/*----- PROTECTED REGION ID(MCCE2Electrometers::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	MCCE2Electrometers::Additional Classes Definitions

}	//	End of namespace

#endif   //	MCCE2Electrometers_H
