/*----- PROTECTED REGION ID(MCCE2ElectrometersClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        MCCE2ElectrometersClass.cpp
//
// description : C++ source for the MCCE2ElectrometersClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the MCCE2Electrometers once per process.
//
// project :     Novelec MCCE-2 Electrometers
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <MCCE2Electrometers.h>
#include <MCCE2ElectrometersClass.h>

/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass.cpp

//-------------------------------------------------------------------
/**
 *	Create MCCE2ElectrometersClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_MCCE2Electrometers_class(const char *name) {
		return MCCE2Electrometers_ns::MCCE2ElectrometersClass::init(name);
	}
}

namespace MCCE2Electrometers_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
MCCE2ElectrometersClass *MCCE2ElectrometersClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::MCCE2ElectrometersClass(string &s)
 * description : 	constructor for the MCCE2ElectrometersClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
MCCE2ElectrometersClass::MCCE2ElectrometersClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering MCCE2ElectrometersClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::constructor

	cout2 << "Leaving MCCE2ElectrometersClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::~MCCE2ElectrometersClass()
 * description : 	destructor for the MCCE2ElectrometersClass
 */
//--------------------------------------------------------
MCCE2ElectrometersClass::~MCCE2ElectrometersClass()
{
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
MCCE2ElectrometersClass *MCCE2ElectrometersClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new MCCE2ElectrometersClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
MCCE2ElectrometersClass *MCCE2ElectrometersClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		RangeUPClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RangeUPClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RangeUPClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->range_up());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RangeDOWNClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RangeDOWNClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RangeDOWNClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->range_down());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetZeroVFFunctionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetZeroVFFunctionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetZeroVFFunctionClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->set_zero_vffunction());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetOffsetZeroV1FunctionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetOffsetZeroV1FunctionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetOffsetZeroV1FunctionClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->set_offset_zero_v1_function());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetLeakageZeroV2FunctionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetLeakageZeroV2FunctionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetLeakageZeroV2FunctionClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->set_leakage_zero_v2_function());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetTestFunctionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetTestFunctionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetTestFunctionClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->set_test_function());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetMeasureFunctionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetMeasureFunctionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetMeasureFunctionClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->set_measure_function());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MCCE2_ONClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MCCE2_ONClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MCCE2_ONClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->mcce2__on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MCCE2_OFFClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MCCE2_OFFClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MCCE2_OFFClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->mcce2__off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		LocalClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *LocalClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "LocalClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->local());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RemoteClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RemoteClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RemoteClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->remote());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ClearRegistersClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ClearRegistersClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ClearRegistersClass::execute(): arrived" << endl;
	((static_cast<MCCE2Electrometers *>(device))->clear_registers());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetRangeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetRangeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetRangeClass::execute(): arrived" << endl;
	return insert((static_cast<MCCE2Electrometers *>(device))->get_range());
}

//--------------------------------------------------------
/**
 * method : 		SetRangeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetRangeClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetRangeClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<MCCE2Electrometers *>(device))->set_range(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetModeClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetModeClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetModeClass::execute(): arrived" << endl;
	return insert((static_cast<MCCE2Electrometers *>(device))->get_mode());
}

//--------------------------------------------------------
/**
 * method : 		GetPolarityClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetPolarityClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetPolarityClass::execute(): arrived" << endl;
	return insert((static_cast<MCCE2Electrometers *>(device))->get_polarity());
}

//--------------------------------------------------------
/**
 * method : 		SetPolarityClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetPolarityClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetPolarityClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<MCCE2Electrometers *>(device))->set_polarity(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetHzFilterClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetHzFilterClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetHzFilterClass::execute(): arrived" << endl;
	return insert((static_cast<MCCE2Electrometers *>(device))->get_hz_filter());
}

//--------------------------------------------------------
/**
 * method : 		SetHzFilterClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetHzFilterClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetHzFilterClass::execute(): arrived" << endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<MCCE2Electrometers *>(device))->set_hz_filter(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetGainClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetGainClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetGainClass::execute(): arrived" << endl;
	return insert((static_cast<MCCE2Electrometers *>(device))->get_gain());
}

//--------------------------------------------------------
/**
 * method : 		SetGainClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetGainClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SetGainClass::execute(): arrived" << endl;
	Tango::DevUShort argin;
	extract(in_any, argin);
	((static_cast<MCCE2Electrometers *>(device))->set_gain(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetElectrometerTypeStrClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetElectrometerTypeStrClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetElectrometerTypeStrClass::execute(): arrived" << endl;
	Tango::DevUShort argin;
	extract(in_any, argin);
	return insert((static_cast<MCCE2Electrometers *>(device))->get_electrometer_type_str(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum MCCE2ElectrometersClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum MCCE2ElectrometersClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum MCCE2ElectrometersClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "ProxyName";
	prop_desc = "The name of the device which manages the communication.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Electrometer1Address";
	prop_desc = "The first electrometer address configured. <br />\nNote : if not connected, push 0 or let empty the property.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Electrometer2Address";
	prop_desc = "The second electrometer address configured. <br />\nNote : if not connected, push 0 or let empty the property.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ComProtocol";
	prop_desc = "Communication protocal: ETHERNET/SERIAL";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Novelec MCCE-2 Electrometers");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class allows you to control all MCCE-2 Novelec electrometers");
	str_desc.push_back("through a Serial bus.");
	str_desc.push_back("<br> Supported types :");
	str_desc.push_back("<br> Novelec Electrometers : MCCE2");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("MCCE2Electrometers");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Tango::Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new MCCE2Electrometers(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	//erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		MCCE2Electrometers *dev = static_cast<MCCE2Electrometers *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::attribute_factory_before
	//	Attribute : electrometerChannel
	electrometerChannelAttrib	*electrometerchannel = new electrometerChannelAttrib();
	Tango::UserDefaultAttrProp	electrometerchannel_prop;
	electrometerchannel_prop.set_description("MCCE2 electrometer have two channels to support two amplifiers.\nWARN : default is 0 (please set this value first).");
	electrometerchannel_prop.set_label("electrometer channel");
	electrometerchannel_prop.set_unit(" ");
	electrometerchannel_prop.set_standard_unit(" ");
	electrometerchannel_prop.set_display_unit(" ");
	electrometerchannel_prop.set_format("%1.0d");
	//	max_value	not set for electrometerChannel
	//	min_value	not set for electrometerChannel
	//	max_alarm	not set for electrometerChannel
	//	min_alarm	not set for electrometerChannel
	//	max_warning	not set for electrometerChannel
	//	min_warning	not set for electrometerChannel
	//	delta_t	not set for electrometerChannel
	//	delta_val	not set for electrometerChannel
	
	electrometerchannel->set_default_properties(electrometerchannel_prop);
	//	Not Polled
	electrometerchannel->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(electrometerchannel);

	//	Attribute : range1
	range1Attrib	*range1 = new range1Attrib();
	Tango::UserDefaultAttrProp	range1_prop;
	range1_prop.set_description("The channel one MCCE2 range.");
	range1_prop.set_label("range1");
	range1_prop.set_unit(" ");
	range1_prop.set_standard_unit(" ");
	range1_prop.set_display_unit(" ");
	range1_prop.set_format("%s");
	//	max_value	not set for range1
	//	min_value	not set for range1
	//	max_alarm	not set for range1
	//	min_alarm	not set for range1
	//	max_warning	not set for range1
	//	min_warning	not set for range1
	//	delta_t	not set for range1
	//	delta_val	not set for range1
	
	range1->set_default_properties(range1_prop);
	//	Not Polled
	range1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(range1);

	//	Attribute : range2
	range2Attrib	*range2 = new range2Attrib();
	Tango::UserDefaultAttrProp	range2_prop;
	range2_prop.set_description("The channel two MCCE range.");
	range2_prop.set_label("range2");
	range2_prop.set_unit(" ");
	range2_prop.set_standard_unit(" ");
	range2_prop.set_display_unit(" ");
	range2_prop.set_format("%s");
	//	max_value	not set for range2
	//	min_value	not set for range2
	//	max_alarm	not set for range2
	//	min_alarm	not set for range2
	//	max_warning	not set for range2
	//	min_warning	not set for range2
	//	delta_t	not set for range2
	//	delta_val	not set for range2
	
	range2->set_default_properties(range2_prop);
	//	Not Polled
	range2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(range2);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::command_factory()
{
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::command_factory_before


	//	Command RangeUP
	RangeUPClass	*pRangeUPCmd =
		new RangeUPClass("RangeUP",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pRangeUPCmd);

	//	Command RangeDOWN
	RangeDOWNClass	*pRangeDOWNCmd =
		new RangeDOWNClass("RangeDOWN",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pRangeDOWNCmd);

	//	Command SetZeroVFFunction
	SetZeroVFFunctionClass	*pSetZeroVFFunctionCmd =
		new SetZeroVFFunctionClass("SetZeroVFFunction",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetZeroVFFunctionCmd);

	//	Command SetOffsetZeroV1Function
	SetOffsetZeroV1FunctionClass	*pSetOffsetZeroV1FunctionCmd =
		new SetOffsetZeroV1FunctionClass("SetOffsetZeroV1Function",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetOffsetZeroV1FunctionCmd);

	//	Command SetLeakageZeroV2Function
	SetLeakageZeroV2FunctionClass	*pSetLeakageZeroV2FunctionCmd =
		new SetLeakageZeroV2FunctionClass("SetLeakageZeroV2Function",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetLeakageZeroV2FunctionCmd);

	//	Command SetTestFunction
	SetTestFunctionClass	*pSetTestFunctionCmd =
		new SetTestFunctionClass("SetTestFunction",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetTestFunctionCmd);

	//	Command SetMeasureFunction
	SetMeasureFunctionClass	*pSetMeasureFunctionCmd =
		new SetMeasureFunctionClass("SetMeasureFunction",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetMeasureFunctionCmd);

	//	Command MCCE2_ON
	MCCE2_ONClass	*pMCCE2_ONCmd =
		new MCCE2_ONClass("MCCE2_ON",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pMCCE2_ONCmd);

	//	Command MCCE2_OFF
	MCCE2_OFFClass	*pMCCE2_OFFCmd =
		new MCCE2_OFFClass("MCCE2_OFF",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pMCCE2_OFFCmd);

	//	Command Local
	LocalClass	*pLocalCmd =
		new LocalClass("Local",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pLocalCmd);

	//	Command Remote
	RemoteClass	*pRemoteCmd =
		new RemoteClass("Remote",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pRemoteCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command ClearRegisters
	ClearRegistersClass	*pClearRegistersCmd =
		new ClearRegistersClass("ClearRegisters",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"no argin",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pClearRegistersCmd);

	//	Command GetRange
	GetRangeClass	*pGetRangeCmd =
		new GetRangeClass("GetRange",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"The actual electrometer range",
			Tango::OPERATOR);
	command_list.push_back(pGetRangeCmd);

	//	Command SetRange
	SetRangeClass	*pSetRangeCmd =
		new SetRangeClass("SetRange",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"The range to apply on the electrometer",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetRangeCmd);

	//	Command GetMode
	GetModeClass	*pGetModeCmd =
		new GetModeClass("GetMode",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"The electrometer mode (MEASURE, LEAKAGE ...)",
			Tango::EXPERT);
	command_list.push_back(pGetModeCmd);

	//	Command GetPolarity
	GetPolarityClass	*pGetPolarityCmd =
		new GetPolarityClass("GetPolarity",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"no argin",
			"The electrometer polarity",
			Tango::EXPERT);
	command_list.push_back(pGetPolarityCmd);

	//	Command SetPolarity
	SetPolarityClass	*pSetPolarityCmd =
		new SetPolarityClass("SetPolarity",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"POSITIVE or NEGATIVE",
			"no argout",
			Tango::OPERATOR);
	command_list.push_back(pSetPolarityCmd);

	//	Command GetHzFilter
	GetHzFilterClass	*pGetHzFilterCmd =
		new GetHzFilterClass("GetHzFilter",
			Tango::DEV_VOID, Tango::DEV_SHORT,
			"no argin",
			"The MCCE2 cut-off frequency in Hz",
			Tango::EXPERT);
	command_list.push_back(pGetHzFilterCmd);

	//	Command SetHzFilter
	SetHzFilterClass	*pSetHzFilterCmd =
		new SetHzFilterClass("SetHzFilter",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"The MCCE2 cut-off frequency in Hz",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetHzFilterCmd);

	//	Command GetGain
	GetGainClass	*pGetGainCmd =
		new GetGainClass("GetGain",
			Tango::DEV_VOID, Tango::DEV_SHORT,
			"no argin",
			"The MCCE2 gain",
			Tango::EXPERT);
	command_list.push_back(pGetGainCmd);

	//	Command SetGain
	SetGainClass	*pSetGainCmd =
		new SetGainClass("SetGain",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"The new MCCE-2 gain",
			"no argout",
			Tango::EXPERT);
	command_list.push_back(pSetGainCmd);

	//	Command GetElectrometerTypeStr
	GetElectrometerTypeStrClass	*pGetElectrometerTypeStrCmd =
		new GetElectrometerTypeStrClass("GetElectrometerTypeStr",
			Tango::DEV_USHORT, Tango::DEV_STRING,
			"channel number",
			"the electrometer type as string",
			Tango::OPERATOR);
	command_list.push_back(pGetElectrometerTypeStrCmd);

	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		MCCE2ElectrometersClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void MCCE2ElectrometersClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		MCCE2Electrometers *dev = static_cast<MCCE2Electrometers *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : MCCE2ElectrometersClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *MCCE2ElectrometersClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(MCCE2ElectrometersClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	MCCE2ElectrometersClass::Additional Methods
} //	namespace
